/* Copyright (c) 1996--1999 Geoff Pike. */
/* All rights reserved. */

/* Floater is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. */

/* This software is provided "as is" and comes with absolutely no */
/* warranties.  Geoff Pike is not liable for damages under any */
/* circumstances.  Support is not provided.  Use at your own risk. */

/* Personal, non-commercial use is allowed.  Attempting to make money */
/* from Floater or products or code derived from Floater is not allowed */
/* without prior written consent from Geoff Pike.  Anything that remotely */
/* involves commercialism, including (but not limited to) systems that */
/* show advertisements while being used and systems that collect */
/* information on users that is later sold or traded require prior */
/* written consent from Geoff Pike. */
char *helpdescriptions = "\n"
"	accept\n"
"Accept declarer's claim.  Must be used by each defender for a claim to\n"
"be accepted.\n"
"	alert\n"
"\"Alert some ... text ...\" is equivalent equivalent to \"explain Alert!\n"
"some ... text ...\" and is traditionally used to self-alert bids or\n"
"carding that is slightly unusual.  \"Redalert\" should be used for highly\n"
"unusual bids or carding.\n"
"	autodeal\n"
"After a certain amount of time elapses at the end of a hand, Floater\n"
"automatically deals a new hand if four people are seated.  To control\n"
"the timing, \"autodeal <N>\" sets the number of seconds to wait between\n"
"hands.  With no arguments, \"autodeal\" toggles on and off whether new\n"
"hands are ever dealt automatically.  (By the way, you must be host of\n"
"the table for your autodeal setting to have any effect.)\n"
"	beep\n"
"You may beep someone at your table by doing \"beep <name>\" (e.g., \"beep\n"
"Joe Smith\"), or you may beep everyone at your table by just doing\n"
"\"beep.\"  The bell will ring on the recipient's machine and everyone at\n"
"the table will see a message indicating who has beeped whom.\n"
"	beepAtMyTurn\n"
"There is an option that causes Floater to beep when it becomes your\n"
"turn to bid or play.  To toggle the described behavior, invoke this\n"
"command.  To turn it off, invoke this command with the argument \"no.\"\n"
"To turn it on, invoke this command with the argument \"yes.\"  See also\n"
"the options menu on the GUI.\n"
"	bid\n"
"Make a call.  For example, to bid 3 Notrump, do \"bid 3n\".  Each strain\n"
"is represented by a single letter: c for clubs, d for diamonds, h for\n"
"hearts, s for spades, and n for notrump.  \"Bid p,\" \"bid pass,\" \"bid\n"
"x,\" \"bid xx,\" \"bid double,\" and \"bid redouble\" have the obvious\n"
"meanings.  Unless you have customized the bindings (see \"bind\"), the\n"
"word \"bid\" may be omitted (\"3n\" is the same as \"bid 3n\" and so on).\n"
"	bidButtons\n"
"If you are using the GUI, by default (unless your screen is small)\n"
"Floater displays, during the auction, a set of buttons for bidding.\n"
"To toggle the described behavior, invoke this command.  To turn it\n"
"off, invoke this command with the argument \"no.\"  To turn it on,\n"
"invoke this command with the argument \"yes.\"  See also the options\n"
"menu on the GUI.\n"
"	bind\n"
"Bind is used to create shorthand ways of specifying any command or\n"
"sequence of commands.  For example, \"bind typ say Thanks, pard!\" would\n"
"allow you to subsequently use \"typ\" as if it were a normal command.\n"
"Another example: Blue Club players might do \"bind 1c bid 1c; explain\n"
"Blue club: 17+ points, any distribution.\"\n"
"	bottom\n"
"If you are using the textual user interface, bottom is used to go to\n"
"the bottom of the scrolling talk window.  You may also use the scroll\n"
"command or the up and down array keys to select the portion of the\n"
"scrolling talk window you view.\n"
"	bug\n"
"Do \"bug <arbitrarily long one-line description>\" and an email message\n"
"containing your description and a dump of some internal variables will\n"
"be sent to floater-bugs@priam.cs.berkeley.edu.\n"
"	bugs\n"
"Display the `BUGS' file.\n"
"	c\n"
"Play your lowest club.\n"
"	cards\n"
"Remind me what my cards were at the beginning of the hand.  May also\n"
"be used by kibitzers, with analogous meaning.\n"
"	cc\n"
"Invokes the textual user interface's convention card editor.  By\n"
"default you will be editing your side's convention card, or NS's if\n"
"you are not seated.  (\"Editing\" of a conventioning card other than\n"
"your own is really limited to viewing; changes are not allowed.)  The\n"
"three forms of the command are \"cc,\" \"cc NS,\" and \"cc EW.\"  If you are\n"
"using the GUI, \"cc\" is equivalent to \"ccdump\" because there is no\n"
"built-in editor for the GUI.\n"
"	ccdump\n"
"Show the specified convention card (e.g. \"ccdump NS\").  If none is specified,\n"
"show my convention card if I am seated or NS's otherwise.  Furthermore,\n"
"you may also specify a range of line numbers to display (e.g. \"1-5\" or\n"
"\"23-\" or \"-9\" or just \"17\").  Put the range first, if any, first;\n"
"so, \"ccdump -3\" or \"ccdump 12-16 NS.\"\n"
"	ccload\n"
"Load a convention card from the named text file (e.g. \"ccload sam.cc\")\n"
"and make it the convention card for my side.  You must be seated to\n"
"invoke the ccload command.\n"
"	ccsave\n"
"Save your current convention card to the named text file.\n"
"	changelog\n"
"Display the log of changes to Floater.\n"
"	children\n"
"Show who gets messages from me in the communication tree.  Primarily\n"
"intended for debugging.\n"
"	claim\n"
"As declarer, suggest to the defense that you are certain of some\n"
"number of tricks, and further play is not necessary.  The defenders\n"
"will be shown all four hands and may then use \"accept\" or \"reject\" and/or\n"
"continue playing.  Simply doing \"claim\" claims the rest of the tricks;\n"
"\"claim 3\" would mean a claim to make 3 of the remaining tricks;\n"
"\"claim -2\" would be a claim to make all but 2 of the\n"
"remaining tricks; \"claim 0\" means concede the rest; and \"claim +3\"\n"
"would be a claim for the contract plus 3 overtricks.\n"
"	close\n"
"Stop hosting (or close) your table.  You must be hosting a table for\n"
"this to be allowed.\n"
"	competitive\n"
"Turns on competitive mode.  This is the default.  Results will be\n"
"reported by email for IMPs and MPs.  (Competitive mode is not relevant\n"
"to hearts or rubber bridge.)\n"
"	confusing\n"
"Display the `CONFUSING' file.\n"
"	copyright\n"
"Display copyright and warranty information.\n"
"	d\n"
"Play your lowest diamond.\n"
"	deal\n"
"Go on to the next hand.  May only be used by the host of the table.\n"
"	deiconifyIfBeeped\n"
"Normally when you are beeped by another player (see \"beep\"), your\n"
"Floater window is deiconified if it had been iconified.  This applies\n"
"only to the GUI.  To toggle the described behavior, invoke this\n"
"command.  To turn it off, invoke this command with the argument \"no.\"\n"
"To turn it on, invoke this command with the argument \"yes.\"  See also\n"
"the options menu on the GUI.\n"
"	disconnect\n"
"Close all network connections.  You will become a \"lurker.\"  If you\n"
"are hosting a table at the time you issue the command, it is\n"
"equivalent to \"close.\"\n"
"	down\n"
"A variant of the \"claim\" command.  For example, \"Down 2\" is a claim\n"
"for 2 fewer tricks than you have contracted for.\n"
"	e (or east)\n"
"If the East seat is available, take it.\n"
"	east (or e)\n"
"If the East seat is available, take it.\n"
"	emailchange\n"
"This command may be used to inform the Floater login server of a change in\n"
"your email address.  (Such changes do not apply to the Floater mailing list.)\n"
"You must be logged in to use the command, and you should specify your\n"
"full email address as an argument to the command (e.g., \"emailchange\n"
"bob@aol.com\").\n"
"	execute\n"
"Read a file and interpret the lines of the file as if they were typed\n"
"in on the command line at that moment.  E.g., \"execute ~/floater/foo.\"\n"
"	explain\n"
"Say something that everyone at the table except partner can hear.\n"
"This is typically used to explain conventional calls to the opponents\n"
"and kibitzers, among other things.\n"
"	find\n"
"Find information about people.  For example, \"find Joe Bob, elmo\" will\n"
"attempt to find information about the players Joe Bob and elmo.  Any\n"
"number of names, separated by commas, is allowed.  Recent information\n"
"about a player's location, if available, is among the things displayed.\n"
"	follow\n"
"Play the card of the named rank.  E.g. \"follow k.\"  Unless you have\n"
"customized the bindings (see \"bind\"), the word \"follow\" may be omitted\n"
"(\"7\" is the same as \"follow 7\" and so on).\n"
"	font\n"
"If you are using the GUI, you may change the font size for the matrix\n"
"and auction by doing \"font large,\" \"font medium,\" or \"font small.\" \n"
"(To change the font size for the talk window, use the \"talkfont\" command.)\n"
"	h\n"
"Play your lowest heart.\n"
"	hideAuction\n"
"If you are using the GUI, you may use this command to control when\n"
"during the first trick the auction is removed from view.  The default,\n"
"which can also be achieved by do `hideAuction -1' is to removed the\n"
"auction after trick one.  The command `hideAuction N' (for positive N)\n"
"will cause the auction to be hidden at the end of trick one or N\n"
"seconds after the end of the auction, whichever comes first.\n"
"	hideCommandLine\n"
"If you are using the GUI, you may have either a talk line by itself,\n"
"or a talk line and a command line.  Use this command with no arguments\n"
"to toggle between the two, or use it with an argument of \"yes\" or \"no\"\n"
"with the obvious meaning.  Note that commands may be executed on the talk\n"
"line by starting the line with a slash (e.g., \"/pass\").\n"
"	hideMatrix\n"
"If you are using the GUI and have a small screen, Floater will, by\n"
"default, hide the matrix during the auction to give more room to other\n"
"things on the screen.  (Your cards appear at the top of the Floater\n"
"window.)  To toggle the described behavior, invoke this command.  To\n"
"turn it off, invoke this command with the argument \"no.\"  To turn it\n"
"on, invoke this command with the argument \"yes.\"  See also the options\n"
"menu on the GUI.\n"
"	host\n"
"Host a table.\n"
"	ip\n"
"Display the IP address and port number that others may use to connect\n"
"to you.\n"
"	join\n"
"Join a table.  You must specify the name of the host of the table you\n"
"wish to join, e.g., \"join moe\".  (Alternatively, you may specify an IP\n"
"address and port separated by a colon, e.g., \"join 128.110.38.14:8765.\"\n"
"Or, to join a table hosted on your local machine, you may omit the IP\n"
"address and simply put the port number after a colon.)\n"
"	kibbitz\n"
"If you are sitting North, South, East, or West, this is the way to get up.\n"
"	last\n"
"Show the previous trick.\n"
"	lho\n"
"Say something to your left-hand opponent.  E.g. \"lho Is that for penalty?\"\n"
"	login\n"
"Connect to the login server and transmit your account name and\n"
"password.  In return, the login server will check your password and\n"
"authenticate you to let you play under that account name.  In\n"
"addition, a list of tables currently in play will be sent to you,\n"
"allowing the \"tables\" command to give up-to-date information.\n"
"	make\n"
"A variant of the \"claim\" command.  With no arguments it is a claim to\n"
"make the contract exactly; with a positive integer argument it is a\n"
"claim to make a grand total of that number of tricks plus six.\n"
"	n (or north)\n"
"If the North seat is available, take it.\n"
"	newuser\n"
"Log in as a new user (see also \"login\").\n"
"	noncompetitive\n"
"Turns off competitive mode.  You will play the same hands as you would\n"
"otherwise, but results will not be reported by email.  (Not relevant\n"
"for hearts or rubber bridge.)\n"
"	north (or n)\n"
"If the North seat is available, take it.\n"
"	note\n"
"Set the text that is listed alongside my table's name when people use\n"
"the \"tables\" command.  For example, \"note Need 1!\"  You must be host\n"
"of the table.\n"
"	opp\n"
"Say something just to your opponents.  Frequently one would use\n"
"\"explain\" instead so that the kibitzers could also hear.\n"
"	parent\n"
"Show my parent in the communication tree.  Primarily intended for debugging.\n"
"	password\n"
"Change the password for an account.\n"
"	previous\n"
"Show the previous hand.\n"
"	play\n"
"Play a card.  Cards are specified suit first, rank second.  For\n"
"example, \"play c3\" would play the 3 of clubs.  Unless you have\n"
"customized the bindings (see \"bind\"), the word \"play\" may be omitted\n"
"(\"c2\" is the same as \"play c2\" and so on).  In Hearts, this command is\n"
"also used to add or remove a card from the set of cards you wish to\n"
"pass to your opponent before the play of the hand.\n"
"	quit\n"
"Terminate Floater.\n"
"	randomplay\n"
"Toggle a switch that, when set, causes automatic random plays or bids\n"
"whenever it is your turn.  Intended for debugging.\n"
"	readme\n"
"Display the `README' file.\n"
"	redalert\n"
"\"Redalert some ... text ...\" is equivalent equivalent to \"explain Red Alert!\n"
"some ... text ...\" and is traditionally used to self-alert bids or\n"
"carding that is highly unusual.  \"Alert\" should be used for only slightly\n"
"unusual bids or carding.\n"
"	reject\n"
"Reject declarer's claim.  A rejection from either defender nixes the\n"
"claim regardless of what the other defender may have done.  Others at\n"
"the table are shown only that the claim was rejected, not by whom.\n"
"	retract\n"
"Declarer may use this command to retract a claim.\n"
"	review\n"
"Review the auction.\n"
"	rho\n"
"Say something to your right-hand opponent.  E.g. \"rho What is 2D?\"\n"
"	s\n"
"If the south seat is available, try to sit down.  Otherwise, if you\n"
"are seated and it is your turn to play a card, play your lowest spade. \n"
"	say\n"
"Say something to everyone present.  E.g. \"say Hello There!\"\n"
"	score\n"
"Select the form of scoring for subsequent deals.  The valid uses of\n"
"the command are \"score IMP\" and \"score MP.\"  See also \"competitive\"\n"
"and \"noncompetitive.\"\n"
"	scroll\n"
"If you are using the textual user interface, scroll is used to change\n"
"which portion of the scrolling text window you view.  For example,\n"
"\"scroll -10\" takes you back 10 lines; \"scroll 20\" takes you forward 20\n"
"lines.  You may also use the bottom command or the up and down array\n"
"keys to select the portion of the scrolling talk window you view.\n"
"	separateTalk\n"
"This command applies only to the GUI.  By default, the messages (e.g.,\n"
"from people talking) that Floater displays appear in a scrollable box\n"
"towards the bottom of the main Floater window.  If invoked with no\n"
"arguments, this command toggles whether that is true or whether\n"
"Floater has a separate window just for those messages.  It also may be\n"
"invoked with an argument of \"yes\" or \"no,\" with the obvious meaning.\n"
"See also the options menu in the GUI.\n"
"	south (or s)\n"
"If the South seat is available, take it.\n"
"	spec\n"
"Become a double-dummy spectator.\n"
"	tables\n"
"List all tables.\n"
"	talkfont\n"
"If you are using the GUI, you may change the font size for the talk\n"
"window by doing \"talkfont large,\" \"talkfont medium,\" or \"talkfont small.\" \n"
"(See also the \"font\" command.)\n"
"	w (or west)\n"
"If the West seat is available, take it.\n"
"	warranty\n"
"Display copyright and warranty information.\n"
"	west (or w)\n"
"If the West seat is available, take it.\n"
"	who\n"
"List who is at the table I am at.\n"
"	whois\n"
"An IRC user suggested that \"whois\" should be interchangeable with\n"
"\"find\" in Floater.  See find.\n"
"	.\n"
"Play your smallest card of the suit led.\n"
/* Copyright (c) 1996--1999 Geoff Pike. */
/* All rights reserved. */

/* Floater is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. */

/* This software is provided "as is" and comes with absolutely no */
/* warranties.  Geoff Pike is not liable for damages under any */
/* circumstances.  Support is not provided.  Use at your own risk. */

/* Personal, non-commercial use is allowed.  Attempting to make money */
/* from Floater or products or code derived from Floater is not allowed */
/* without prior written consent from Geoff Pike.  Anything that remotely */
/* involves commercialism, including (but not limited to) systems that */
/* show advertisements while being used and systems that collect */
/* information on users that is later sold or traded require prior */
/* written consent from Geoff Pike. */
;

char *helpcommands = "\n"
"accept alert autodeal beep beepAtMyTurn bid bidButtons bind bottom bug bugs c cards cc ccdump ccload ccsave changelog children claim close competitive confusing copyright d deal deiconifyIfBeeped disconnect down e (or east) east (or e) emailchange execute explain find follow font h hideAuction hideCommandLine hideMatrix host ip join kibbitz last lho login make n (or north) newuser noncompetitive north (or n) note opp parent password previous play quit randomplay readme redalert reject retract review rho s say score scroll separateTalk south (or s) spec tables talkfont w (or west) warranty west (or w) who whois . "/* Copyright (c) 1996--1999 Geoff Pike. */
/* All rights reserved. */

/* Floater is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. */

/* This software is provided "as is" and comes with absolutely no */
/* warranties.  Geoff Pike is not liable for damages under any */
/* circumstances.  Support is not provided.  Use at your own risk. */

/* Personal, non-commercial use is allowed.  Attempting to make money */
/* from Floater or products or code derived from Floater is not allowed */
/* without prior written consent from Geoff Pike.  Anything that remotely */
/* involves commercialism, including (but not limited to) systems that */
/* show advertisements while being used and systems that collect */
/* information on users that is later sold or traded require prior */
/* written consent from Geoff Pike. */
;
